package edu.nyu.scps.context;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

public class ContextActivity extends Activity {
	//ID numbers of TextViews
	private static final int[] id = {
		R.id.red,
		R.id.green,
		R.id.blue
	};

	private static final Item[] item = {
		new Item("Red",              R.id.red,   Color.rgb(255,   0,   0)),
		new Item("Dark Red",         R.id.red,   Color.rgb(139,   0,   0)),
		new Item("Indian Red",       R.id.red,   Color.rgb(205,  92,  92)),
		new Item("Orange Red",       R.id.red,   Color.rgb(255,  69,  69)),
		new Item("Violet Red",       R.id.red,   Color.rgb(208,  32, 144)),

		new Item("Green",            R.id.green, Color.rgb(  0, 255,   0)),
		new Item("Dark Green",       R.id.green, Color.rgb(  0, 100,   0)),
		new Item("Dark Olive Green", R.id.green, Color.rgb( 85, 107,  47)),
		new Item("Forrest Green",    R.id.green, Color.rgb( 34, 139,  37)),
		new Item("Lawn Green",       R.id.green, Color.rgb(124, 252,   0)),
		new Item("Lime Green",       R.id.green, Color.rgb( 50, 205,  50)),
		new Item("Spring Green",     R.id.green, Color.rgb(  0, 255, 127)),

		new Item("Blue",             R.id.blue,  Color.rgb(  0,   0, 255)),
		new Item("Cornflower Blue",  R.id.blue,  Color.rgb(100, 149, 237)),
		new Item("Midnight Blue",    R.id.blue,  Color.rgb( 25,  25, 112)),
		new Item("Navy Blue",        R.id.blue,  Color.rgb(  0,   0, 128)),
		new Item("Royal Blue",       R.id.blue,  Color.rgb( 65, 105, 225)),
		new Item("Sky Blue",         R.id.blue,  Color.rgb(135, 206, 235))
	};

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		for (int i = 0; i < id.length; ++i) {
			registerForContextMenu(findViewById(id[i]));
		}
	}

	@Override
	public void onCreateContextMenu(ContextMenu contextMenu, View view, ContextMenuInfo contextMenuInfo) {
		super.onCreateContextMenu(contextMenu, view, contextMenuInfo);

		//Add MenuItems to the empty ContextMenu.
		for (int i = 0; i < item.length; ++i) {
			if (item[i].id == view.getId()) {
				contextMenu.add(Menu.NONE, i, Menu.FIRST + i, item[i].name);
			}
		}
	}

	@Override
	public boolean onContextItemSelected(MenuItem menuItem) {
		final int i = menuItem.getItemId();
		if (i < 0 || i >= item.length) {
			return super.onContextItemSelected(menuItem);
		}

		final TextView textView = (TextView)findViewById(item[i].id);
		textView.setText(item[i].name);
		textView.setBackgroundColor(item[i].color);
		return true;
	}

	private static class Item {
		String name;
		int id;
		int color;

		Item(String name, int id, int color) {
			this.name = name;
			this.id = id;
			this.color = color;
		}
	}

}